#pragma hdrstop
#include <condefs.h>

#include "ProfileCreator.h"

//---------------------------------------------------------------------------
USEUNIT("ProfileCreator.cpp");
//---------------------------------------------------------------------------
#pragma argsused
int main(int argc, char* argv[])
{
        int file_name_length = 1000;

        char* neff_file_name = new char[file_name_length];
        char* alphabet_file_name = new char[file_name_length];
        char* alignment_file_name = new char[file_name_length];
        char* subst_matrix_file_name = new char[file_name_length];
        char* profile_file_name = new char[file_name_length];

        strcpy(neff_file_name,"neff.txt");
        strcpy(alphabet_file_name,"alphabet.txt");
        strcpy(subst_matrix_file_name,"gon250.txt");

        strcpy(alignment_file_name,argv[1]);
        strcpy(profile_file_name,argv[2]);

        ProfileCreator profiler;

        if (!profiler.loadTableNEff(neff_file_name)) {
         return 1;
        }
        if (!profiler.loadAlphabet(alphabet_file_name)) {
         return 1;
        }
        if (!profiler.loadAlignment(alignment_file_name)) {
         return 1;
        }
        if (!profiler.loadSubstMatrix(subst_matrix_file_name)) {
         return 1;
        }

        profiler.setPseudocount(5);
        profiler.setLambda(0.225);
        profiler.setSqrtNeffFlag(true);

        profiler.calculateProfile();

        if (!profiler.saveProfile(profile_file_name)) {
         return 1;
        }

        delete[] neff_file_name;
        delete[] alphabet_file_name;
        delete[] alignment_file_name;
        delete[] subst_matrix_file_name;

        delete[] profile_file_name;

        return 0;
}

